/*************************************************************
 * vqueue Queue library
 * Version 1.0.0
 *
 * Implementation of a FIFO queue in C
 *
 * John David Ratliff [jdratlif@cs.indiana.edu]
 * Chris O'Donnell    [chodonne@cs.indiana.edu]
 **************************************************************/

#ifndef __QUEUE_H
#define __QUEUE_H

// a good starting queue sizes
#define DEFAULT_QUEUE_SIZE 100

// boolean values
enum BOOLEAN {FALSE,TRUE};

// the queue structure (queue_t is defined by Solaris headers)
typedef struct {
    void **data;
    unsigned long int size, length;
    unsigned long int in, out;
} vqueue_t;

// queue API
vqueue_t *queue_create(unsigned long int);
void queue_destroy(vqueue_t *);
short int queue_empty(vqueue_t *);
short int queue_full(vqueue_t *);
short int queue_enqueue(vqueue_t *, void *);
short int queue_dequeue(vqueue_t *, void **);

#endif

/******************************************************************************
 *  vqueue Queue Library
 *  Copyright (C) 2002 John David Ratliff [jdratlif@cs.indiana.edu]
 *                     Chris O'Donnell    [chodonne@cs.indiana.edu]
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/

