/*************************************************************
 * CSCI P436 - Operating Systems
 *
 * John David Ratliff jdratlif@cs.indiana.edu
 * Chris O'Donnell chodonne@cs.indiana.edu
 *
 * sbc - Server Benchmark Client
 **************************************************************/

#ifndef __SBC_H
#define __SBC_H

// global constants
#define DEFAULT_HOST	 "localhost"
#define DEFAULT_HTTP_PORT  64201
#define DEFAULT_PROXY_PORT 64202
#define DEFAULT_THREADS  10
#define DEFAULT_REQUESTS 10

#define TEST_FILE_COUNT	 2000

// the SBC version string
#define SBC_VERSION	 "1.2.0"

// result and truth values
enum RESULTS {FAILURE,SUCCESS};
enum BOOLEAN {FALSE,TRUE};

// the client data structure
typedef struct {
    in_addr_t proxy_ip, server_ip;
    uint16_t proxy_port, server_port;
    char http_server[1024], http_port[10];
    short int threads, requests;
} client_data_t;

// function prototypes

// sbc.c
void print_version_info(void);
void print_help_info(void);
void parse_command_line(const int argc, const char **, client_data_t *);
in_addr_t get_ip_address(const char *);
short int connect_to_server(const struct sockaddr *, int *);
int main(int, char **);

#endif

/******************************************************************************
 *  Server Benchmark Client 1.2.0
 *  Copyright (C) 2002 John David Ratliff [jdratlif@cs.indiana.edu]
 *                     Chris O'Donnell    [chodonne@cs.indiana.edu]
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/

